<template>
  <v-form
    ref="form"
    v-model="valid"
    light
    :class="!mobile ? 'px-4 mt-4':''"
  >
    <v-row>
      <v-col cols="12" :class="mobile ? 'pt-4 pb-0' : 'py-0'">
        <v-row>
          <!-- Hapū list -->
          <v-col v-if="hapuField" cols="12" class="pa-1">
            <CustomField
              :fieldDef="hapuField"
              :fieldValue.sync="formData.customFields[hapuField.key]"
              :mobileCols="mobileCols"
              :submitted="submitted"
            />
          </v-col>
          <!-- Title field -->
          <v-col v-if="titleField" :cols="mobile ? 12 : 3" class="pa-1">
            <CustomField
              :fieldDef="titleField"
              :fieldValue.sync="formData.customFields[titleField.key]"
              :mobileCols="mobileCols"
              :submitted="submitted"
            />
          </v-col>
          <!-- Full name -->
          <v-col v-if="hasDefaultField('legalName')" :cols="mobile ? 12 : 9" class="pa-1">
            <v-text-field
              v-model="formData.legalName"
              :label="getLabel('legalName')"
              v-bind="customProps"
              :rules="getFieldRules('legalName')"
            />
          </v-col>
          <!-- Preferred Name -->
          <v-col :cols="mobileCols" class="pa-1">
            <v-text-field
              ref="name"
              v-model="formData.preferredName"
              :label="getLabel('preferredName')"
              v-bind="customProps"
              :rules="getFieldRules('preferredName')"
            />
          </v-col>
          <!-- Alt names -->
          <template v-if="hasDefaultField('altNames')">
            <v-col v-for="(altName, index) in newAltNames"
              :key="`add-alt-name-${index}`"
              cols="12"
              :sm="smScreen ? '12' : '6'"
              class="pa-1"
            >
              <v-text-field
                v-model="formData.altNames.add[index]"
                label="other name"
                append-icon="mdi-delete"
                @click:append="removeAltNameField(index)"
                v-bind="customProps"
                cols="12"
              />
            </v-col>
            <v-col>
              <AddButton
                label="Add another name"
                :align="'flex-end'"
                :justify="justifyBtn"
                :width="'50px'"
                row
                @click="addAltNameField"
              />
            </v-col>
          </template>
        </v-row>

        <v-row>
          <!-- RelatedBy -->
          <v-col v-if="hasDefaultField('relatedBy')" :cols="mobileCols" class="pa-1">
            <v-select
              v-model="formData.relationshipType"
              :label="getLabel('relatedBy')"
              :items="relationshipTypes"
              :menu-props="{ light: true }"
              outlined
              hide-details
              :rules="getFieldRules('relatedBy')"
            />
          </v-col>

          <!-- Order of birth -->
          <v-col v-if="showBirthOrder" :cols="mobileCols" class="pa-1" >
            <v-text-field
              v-model="formData.birthOrder"
              type="number"
              :label="getLabel('birthOrder')"
              min="1"
              v-bind="customProps"
              :rules="getFieldRules('birthOrder')"
            />
          </v-col>

          <!-- gender -->
          <v-col v-if="hasDefaultField('gender')" :cols="mobileCols" class="pa-1">
            <v-select
              v-model="formData.gender"
              :label=" getLabel('gender')"
              :items="genders"
              :menu-props="{ light: true }"
              v-bind="customProps"
              :rules="getFieldRules('gender')"
            />
          </v-col>

          <!-- date of birth -->
          <v-col v-if="hasDefaultField('dateOfBirth')" :cols="mobileCols" class="pa-1">
            <DateIntervalPicker
              :label="getLabel('dateOfBirth')"
              :endLabel="getLabel('dod')"
              allowInterval
              :interval.sync="formData.aliveInterval"
              :hasEndDate.sync="formData.deceased"
              cols='12'
              :field="getField('dateOfBirth')"
              :submitted="submitted"
            />
          </v-col>

          <!-- whangai custom field -->
          <v-col v-if="whangaiField" cols="12" class="pa-1">
            <CustomField
              :fieldDef="whangaiField"
              :fieldValue.sync="formData.customFields[whangaiField.key]"
              :mobileCols="mobileCols"
              :submitted="submitted"
            />
          </v-col>

          <!-- place of birth -->
          <v-col v-if="hasDefaultField('placeOfBirth')"  :cols="mobileCols" class="pa-1">
            <v-text-field
              v-model="formData.placeOfBirth"
              :label="getLabel('birthPlace')"
              v-bind="customProps"
            />
          </v-col>

          <!-- place of death -->
          <template v-if="formData.deceased && hasDefaultField('placeOfDeath')">
            <v-col :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.placeOfDeath"
                :label="getLabel('deathPlace')"
                v-bind="customProps"
              />
            </v-col>
            <v-col v-if="formData.deceased && hasDefaultField('buriedLocation')" :cols="mobileCols" class="pa-1">
              <!-- Burial Location -->
              <v-text-field
                v-model="formData.buriedLocation"
                :label="getLabel('burialLocation')"
                v-bind="customProps"
              />
            </v-col>
          </template>

          <!-- profile description -->
          <v-col v-if="hasDefaultField('description')" cols="12" sm="12" class="pa-1" >
            <!-- Description textarea -->
              <v-textarea
                v-model="formData.description"
                :label="getLabel('description')"
                v-bind="customProps"
                no-resize
                rows="3"
                auto-grow
              />
          </v-col>

          <v-row :class="mobile ? 'pt-4 px-2' : 'pt-6 px-4'">
            <!-- Profession-->
            <v-col v-if="hasDefaultField('profession')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.profession"
                :label="getLabel('profession')"
                v-bind="customProps"
                :rules="getFieldRules('profession')"
              />
            </v-col>

            <!-- Skills -->
            <template v-if="hasDefaultField('education')">
              <v-col v-for="(qualification, index) in formData.education"
                :key="`add-qual-name-${index}`"
                :cols="smScreen ? '12' : '6'"
                class="pa-1"
              >
                <v-text-field
                  v-model="formData.education[index]"
                  label="expertise"
                  append-icon="mdi-delete"
                  @click:append="removeItem(formData.education, index)"
                  v-bind="customProps"
                />
              </v-col>
              <v-col>
                <AddButton
                  label="Add expertise"
                  :align="'flex-start'"
                  :justify="justifyBtn"
                  :width="'50px'"
                  row
                  @click="addEmptyItem(formData.education)"
                />
                <!-- TODO fix label -->
              </v-col>
            </template>

            <!-- Education -->
            <template v-if="hasDefaultField('school')">
              <v-col v-for="(school, index) in formData.school"
                :key="`add-school-name-${index}`"
                :cols="smScreen ? '12' : '6'"
                class="pa-1"
              >
                <v-text-field
                  v-model="formData.school[index]"
                  label="school"
                  append-icon="mdi-delete"
                  @click:append="removeItem(formData.school, index)"
                  v-bind="customProps"
                />
              </v-col>
              <v-col>
                <AddButton
                  label="Add school"
                  :align="'flex-end'"
                  :justify="justifyBtn"
                  :width="'50px'"
                  row
                  @click="addEmptyItem(formData.school)"
                />
                <!-- TODO fix label -->
              </v-col>
            </template>
            <!-- Email -->
            <v-col v-if="hasDefaultField('email')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.email"
                :label="getLabel('email')"
                v-bind="customProps"
                :rules="getFieldRules('email')"
              />
            </v-col>

            <!-- Phone -->
            <v-col v-if="hasDefaultField('phone')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.phone"
                :label="getLabel('phone')"
                v-bind="customProps"
                :rules="getFieldRules('phone')"
              />
            </v-col>

            <!-- Email subscibe field -->
            <v-col v-if="subscribeField" :cols="mobileCols" class="pa-1">
              <CustomField
                :fieldDef="subscribeField"
                :fieldValue.sync="formData.customFields[subscribeField.key]"
                :mobileCols="mobileCols"
                :submitted="submitted"
              />
            </v-col>
          </v-row>

          <v-row :class="mobile ? 'pt-4 px-2' : 'pt-4 px-4'">
            <!-- Address -->
            <v-col v-if="hasDefaultField('address')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.address"
                :label="getLabel('address')"
                v-bind="customProps"
                :rules="getFieldRules('address')"
              />
            </v-col>

            <!-- Post Code -->
            <v-col v-if="hasDefaultField('postCode')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.postCode"
                :label="getLabel('postCode')"
                v-bind="customProps"
                :rules="getFieldRules('postCode')"
              />
            </v-col>

            <!-- City -->
            <v-col v-if="hasDefaultField('city')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.city"
                :label="getLabel('city')"
                v-bind="customProps"
                :rules="getFieldRules('city')"
              />
            </v-col>

            <!-- Country -->
            <v-col v-if="hasDefaultField('country')" :cols="mobileCols" class="pa-1">
              <v-text-field
                v-model="formData.country"
                :label="getLabel('country')"
                v-bind="customProps"
                :rules="getFieldRules('country')"
              />
            </v-col>
          </v-row>

          <v-row :class="mobile ? 'pt-4 px-2' : 'pt-4 px-4'">
            <!-- Same postal address -->
            <v-col v-if="samePostalField" cols="12" class="pa-1 pb-2">
              <CustomField
                :fieldDef="samePostalField"
                :fieldValue.sync="formData.customFields[samePostalField.key]"
                :mobileCols="mobileCols"
                :submitted="submitted"
              />
            </v-col>

            <!-- Remaining custom fields -->
            <template v-if="showCustomFieldsSection">
              <v-col v-for="field in rawCustomFields" :key="field.key" :cols="mobileCols" class="pa-1">
                <CustomField
                  :fieldDef="field"
                  :fieldValue.sync="formData.customFields[field.key]"
                  :mobileCols="mobileCols"
                  :submitted="submitted"
                />
              </v-col>
            </template>
          </v-row>

          <!-- joiningQuestions -->
          <v-row v-if="answers && answers.length" :class="mobile ? 'pt-4 px-2' : 'pt-6 px-4'">
            <p class="overline pa-4 pb-0">Please answer the following questions</p>
            <v-col cols="12" sm="12" v-for="(question, i) in answers" :key="`j-q-${i}`" class="pa-1">
              <v-text-field
                :class="questionIndent(i)"
                v-model="answers[i].value"
                v-bind="customProps"
                :label="answers[i].label"
              />
            </v-col>
          </v-row>

          <v-checkbox
            v-model="declaration"
            label="Please agree to the terms and Conditions*"
            hide-details="auto"
            v-bind="customProps"
            :rules="[v => (Boolean(v)) || 'required field']"
            class="pt-4"
          />
          <div class="declaration">
            <p>
              - I agree to the Whangaroa Papa Hapū (Whangaroa PH) retaining a copy of this form for the specific purpose of establishing a Whangaroa Māori population register to take Whangaroa through the Waitangi Tribunal Reparation (Settlement) Process.
            </p>
            <p>
              - I expect regular notification of progress from the Whangaroa PH;
            </p>
            <p>
              - I will contact the (hapū) should my address or any other details change in the future.
            </p>
          </div>
        </v-row>
      </v-col>
    </v-row>
  </v-form>
</template>

<script>
import AddButton from '@/components/AddButton.vue'
import DateIntervalPicker from '@/components/DateIntervalPicker.vue'
import CustomField from '@/components/profile/CustomField.vue'

import { GENDERS, RELATIONSHIPS } from '@/lib/constants'
import { mapPropToLabel } from '@/lib/custom-field-helpers'
import { setDefaultData, RULES } from '@/lib/form-helpers'

import isEmpty from 'lodash.isempty'
import get from 'lodash.get'
import clone from 'lodash.clone'

export default {
  name: 'ProfileForm',
  components: {
    AddButton,
    DateIntervalPicker,
    CustomField
  },
  props: {
    defaultFields: Array,
    customFields: Array,
    currentTribe: { type: Object, required: true },
    questions: Array
  },
  data () {
    return {
      genders: GENDERS,
      relationshipTypes: RELATIONSHIPS,
      formData: {},
      rules: [v => (!!v && v.length > 0) || 'required field'],
      submitted: false,
      valid: true,
      rawCustomFields: [],

      titleField: null,
      hapuField: null,
      whangaiField: null,
      samePostalField: null,
      subscribeField: null,

      answers: [],
      declaration: false,
      customProps: {
        hideDetails: 'auto',
        placeholder: ' ',
        light: true,
        outlined: true
      }
    }
  },
  mounted () {
    this.formData = setDefaultData(false)
    if (isEmpty(this.formData.education)) {
      this.formData.education = []
    }
    if (isEmpty(this.formData.school)) {
      this.formData.school = []
    }
  },
  watch: {
    customFields: {
      immediate: true,
      handler (newVal) {
        if (newVal.length && this.currentTribe) {
          // seperate hardcode fields location
          const fields = clone(newVal)
          // pick title customField
          this.titleField = this.pickField(fields, 'title')

          // pick Hapū customField
          this.hapuField = (
            this.pickField(fields, 'hapū') ||
            this.pickField(fields, 'hapu')
          )

          this.whangaiField = (
            this.pickField(fields, 'Please tick if you are whangai') ||
            this.pickField(fields, 'Please tick if you are whāngai')
          )

          this.subscribeField = this.pickField(fields, 'Sign up for email distribution')
          this.samePostalField = this.pickField(fields, 'Tick if your postal address is the same as above')

          this.rawCustomFields = fields
          this.formData.customFields = fields.reduce(
            (obj, item) => Object.assign(obj, { [item.key]: item.value }),
            {}
          )
        }
      }
    },
    formData: {
      immediate: true,
      deep: true,
      handler (newVal) {
        this.$emit('update:formData', newVal)
      }
    },
    valid (newVal) {
      this.$emit('update:valid', newVal)
    },
    questions: {
      immediate: true,
      handler (newVal) {
        this.answers = newVal
      }
    },
    answers: {
      immediate: true,
      deep: true,
      handler (newVal) {
        this.$emit('update:answers', newVal)
      }
    }
  },
  computed: {
    newAltNames () {
      return get(this.formData, 'altNames.add', [])
    },
    mobile () {
      return this.$vuetify.breakpoint.xs
    },
    showBirthOrder () {
      if (!this.hasDefaultField('birthOrder')) return false
      else return true
    },
    altNames () {
      return [...this.formData.altNames.value, ...this.formData.altNames.add]
    },
    smScreen () {
      return this.mobile
    },
    mobileCols () {
      return this.smScreen ? '12' : '6'
    },
    justifyBtn () {
      return this.smScreen ? 'start' : 'end'
    },
    /*
    ======== custom fields ==========
    */
    showCustomFieldsSection () {
      return this.customFields.length
    }
  },
  methods: {
    questionIndent (index) {
      switch (index) {
        case 1: return 'ml-8'
        case 2: return 'ml-16'
        case 3: return 'ml-16'
        case 5: return 'ml-8'
        case 6: return 'ml-16'
        case 7: return 'ml-16'
      }
    },
    pickField (arr, label) {
      const index = arr.findIndex(field => (
        field.label === label &&
        field.tombstone === null
      ))
      if (index >= 0) return arr.splice(index, 1)[0]
    },
    async validate () {
      this.submitted = true
      await this.$refs.form.validate()
    },
    hasDefaultField (key) {
      const label = mapPropToLabel(key)
      if (!label) return

      // find in defaultCustomFields
      if ([...this.defaultFields, ...this.customFields].some(field => field.label === label)) {
        return true
      }
    },
    hasOneField (keys) {
      return keys.some(key => this.hasDefaultField(key))
    },
    getFieldRules (key) {
      if (!this.submitted) return
      const label = mapPropToLabel(key)
      if (!label) return []
      const field = [...this.defaultFields, ...this.customFields].find(field => field.label === label)
      if (!field) return []
      const isRequired = field.required ? this.rules : []
      const rules = RULES[key] ? RULES[key] : []
      return [...rules, ...isRequired]
    },
    getField (key) {
      const label = mapPropToLabel(key)
      if (!label) return []
      const field = [...this.defaultFields, ...this.customFields].find(field => field.label === label)
      if (!field) return []
      return field
    },
    getLabel (key) {
      const label = mapPropToLabel(key)
      if (!label) return key
      const field = [...this.defaultFields, ...this.customFields].find(field => field.label === label)
      if (!field) return key
      return field.required ? label + '*' : label
    },
    addAltNameField () {
      this.formData.altNames.add.push(null)
    },
    removeAltName (altName, index) {
      this.formData.altNames.currentState.splice(index, 1)
      this.formData.altNames.remove.push(altName)
    },
    removeAltNameField (index) {
      this.formData.altNames.add.splice(index, 1)
    },
    addEmptyItem (array) {
      array.push('')
    },
    removeItem (array, index) {
      array.splice(index, 1)
    },
    t (key, vars) {
      return mapPropToLabel(key)
    }
  }
}
</script>

<style scoped lang="scss">
  .declaration {
    color:  rgba(0, 0, 0, 0.6);
    padding: 20px
  }
  .custom.v-text-field > .v-input__control > .v-input__slot:before {
    border-style: none;
  }

  .custom.v-text-field > .v-input__control > .v-input__slot:after {
    border-style: none;
  }

  .v-input--checkbox label {
    font-size: 14px;
  }

  .v-input--radio-group__input label {
    font-size: 14px;
  }

  .v-text-field input {
    text-align: center !important;
  }

  .text-field {
    color: rgba(0,0,0,0.6);
    font-size: 0.8em;
    margin: 0;
  }

  .radio-button  > input[type="radio"] {
    opacity: 0;
    position: fixed;
    width: 0;
  }

  .radio-button >  label {
      display: inline-block;
      background-color: #ddd;
      padding: 10px 20px;
      font-family: sans-serif, Arial;
      font-size: 16px;
      border: 2px solid #444;
      border-radius: 4px;
  }

  .radio-button >  label:hover {
    background-color: #dfd;
  }

  .radio-button >  input[type="radio"]:focus + label {
      border: 2px dashed #444;
  }

  .radio-button >  input[type="radio"]:checked + label {
      background-color: #bfb;
      border-color: #4c4;
  }

  .pointer {
    cursor: pointer;
  }

</style>

<style lang="scss">
  // over-ride default giant select dropdowns
  .v-select.v-select--chips:not(.v-text-field--single-line).v-text-field--box .v-select__selections,
  .v-select.v-select--chips:not(.v-text-field--single-line).v-text-field--enclosed .v-select__selections {
    min-height: initial !important;
  }
</style>
